"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _immutable = _interopRequireDefault(require("immutable"));

var _reactIntl = require("react-intl");

var _SearchPending = _interopRequireDefault(require("./SearchPending"));

var _SearchResultTile = _interopRequireDefault(require("./SearchResultTile"));

var _config = _interopRequireDefault(require("../../../config"));

var _SearchResultList = _interopRequireDefault(require("../../../../styles/cspace/SearchResultList.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const propTypes = {
  hits: _propTypes.default.instanceOf(_immutable.default.List),
  isPending: _propTypes.default.bool,
  offset: _propTypes.default.number,
  onHitsUpdated: _propTypes.default.func,
  params: _propTypes.default.instanceOf(_immutable.default.Map).isRequired
};
const defaultProps = {
  hits: _immutable.default.List(),
  isPending: false,
  offset: 0,
  onHitsUpdated: () => undefined
};
const messages = (0, _reactIntl.defineMessages)({
  noResult: {
    "id": "searchResultList.noResult",
    "defaultMessage": "No results found"
  }
});

class SearchResultList extends _react.Component {
  componentDidUpdate(prevProps) {
    const {
      hits,
      onHitsUpdated
    } = this.props;
    const {
      hits: prevHits
    } = prevProps;

    if (hits !== prevHits) {
      onHitsUpdated();
    }
  }

  renderPending() {
    const {
      isPending
    } = this.props;

    if (!isPending) {
      return undefined;
    }

    return /*#__PURE__*/_react.default.createElement(_SearchPending.default, null);
  }

  renderHits() {
    const {
      params,
      hits,
      isPending
    } = this.props;

    if (hits.size === 0 && !isPending) {
      return /*#__PURE__*/_react.default.createElement("p", null, /*#__PURE__*/_react.default.createElement(_reactIntl.FormattedMessage, messages.noResult));
    }

    const gatewayUrl = _config.default.get('gatewayUrl');

    return hits.map((result, index) => /*#__PURE__*/_react.default.createElement(_SearchResultTile.default, {
      gatewayUrl: gatewayUrl,
      index: index,
      key: result.getIn(['_source', 'ecm:name']),
      params: params,
      result: result
    }));
  }

  render() {
    return /*#__PURE__*/_react.default.createElement("div", {
      className: _SearchResultList.default.common,
      ref: this.domNode
    }, this.renderHits(), this.renderPending());
  }

}

exports.default = SearchResultList;
SearchResultList.propTypes = propTypes;
SearchResultList.defaultProps = defaultProps;