"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getParams = exports.default = void 0;

var _immutable = _interopRequireDefault(require("immutable"));

var _actionCodes = require("../constants/actionCodes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (state = _immutable.default.Map(), action) => {
  switch (action.type) {
    case _actionCodes.SET_SEARCH_PARAMS:
      return state.set('params', action.payload);

    case _actionCodes.SET_SEARCH_ENTRY_FORM_PARAM:
      return state.setIn(['params', action.meta.id], action.payload);

    default:
      return state;
  }
};

exports.default = _default;

const getParams = state => state.get('params');

exports.getParams = getParams;